type token =
  | SEMI
  | LPAREN
  | RPAREN
  | LBRACE
  | RBRACE
  | COMMA
  | COLON
  | LBRACKET
  | RBRACKET
  | NEWMAT
  | PLUS
  | MINUS
  | MUL
  | DIVIDE
  | ASSIGN
  | POWER
  | EMUL
  | ERDIV
  | LDIV
  | ELDIV
  | TRANSPOSE
  | EQ
  | NOTEQ
  | LT
  | LTEQ
  | GT
  | GTEQ
  | AND
  | OR
  | NOT
  | IF
  | ELSE
  | ELSEIF
  | FOR
  | WHILE
  | BREAK
  | CONTINUE
  | END
  | FUNCTION
  | LITERAL of (int)
  | FLOATLIT of (float)
  | ID of (string)
  | DATATYPE of (string)
  | STRING of (string)
  | BOOL of (string)
  | EOF

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
